// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RapidEvaluator.pas' rev: 5.00

#ifndef RapidEvaluatorHPP
#define RapidEvaluatorHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Dialogs.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rapidevaluator
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS ESyntaxError;
class PASCALIMPLEMENTATION ESyntaxError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ESyntaxError(const AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ESyntaxError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ESyntaxError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ESyntaxError(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ESyntaxError(const AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ESyntaxError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ESyntaxError(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ESyntaxError(System::PResStringRec ResStringRec, 
		const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ESyntaxError(void) { }
	#pragma option pop
	
};


typedef Byte TByte[65535];

#pragma option push -b-
enum TError { eNo, eMath, eSyntax };
#pragma option pop

#pragma option push -b-
enum TStackItemType { siConst, siVariable, siOperation, siFunction, siExternalFunction };
#pragma option pop

#pragma option push -b-
enum TOpType { otNone, otAdd, otSub, otMul, otDiv, otMod, otPow };
#pragma option pop

class DELPHICLASS TStackItem;
class PASCALIMPLEMENTATION TStackItem : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TStackItemType Kind;
	double ConstValue;
	int Idx;
	TOpType Operation;
	Byte ParamCount;
	__fastcall TStackItem(TStackItemType AKind, double aValue, TOpType AOpType, int AIdx, Byte AParamCount
		);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TStackItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TCommandList;
class PASCALIMPLEMENTATION TCommandList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	int Tag;
	void __fastcall FreeAll(void);
	__fastcall virtual ~TCommandList(void);
	void __fastcall WriteToFile(AnsiString FName);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TCommandList(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS TCode;
class PASCALIMPLEMENTATION TCode : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int SegCodeSize;
	int FPos;
	
public:
	void *seg_code;
	__fastcall TCode(void);
	__fastcall virtual ~TCode(void);
	void __fastcall GrowBuffer(void);
	int __fastcall CodePos( System::ShortString &Subcode);
	void __fastcall AddCodeByte(Byte B);
	void __fastcall AddCodeWord(Word W);
	void __fastcall AddCodeDWord(int I);
	void __fastcall AddCodeDouble(double D);
	void __fastcall Optimize(void);
};


class DELPHICLASS TLookupItem;
class PASCALIMPLEMENTATION TLookupItem : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString Name;
	bool Enabled;
	__fastcall TLookupItem(AnsiString AName);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TLookupItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TAbstractFunction;
class PASCALIMPLEMENTATION TAbstractFunction : public TLookupItem 
{
	typedef TLookupItem inherited;
	
public:
	Byte ParamCount;
	__fastcall TAbstractFunction(AnsiString AName, Byte AParamCount);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TAbstractFunction(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIntFunction;
class PASCALIMPLEMENTATION TIntFunction : public TAbstractFunction 
{
	typedef TAbstractFunction inherited;
	
public:
	int Id;
	__fastcall TIntFunction(AnsiString AName, int AId, Byte AParamCount);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TIntFunction(void) { }
	#pragma option pop
	
};


class DELPHICLASS TExtPointer;
class PASCALIMPLEMENTATION TExtPointer : public TAbstractFunction 
{
	typedef TAbstractFunction inherited;
	
public:
	void *Addr;
	Byte ParamCount;
	__fastcall TExtPointer(AnsiString AName, void * AAddr, Byte AParamCount);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TExtPointer(void) { }
	#pragma option pop
	
};


class DELPHICLASS TLookupTable;
class PASCALIMPLEMENTATION TLookupTable : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	void *FArray[5];
	int FCount;
	TLookupItem* __fastcall GetLookupItem(int Index);
	void * __fastcall Get(int Index);
	
public:
	__fastcall TLookupTable(void);
	__fastcall virtual ~TLookupTable(void);
	void __fastcall FreeItems(void);
	int __fastcall Add(void * Item);
	virtual void __fastcall Clear(void);
	void __fastcall Delete(int Index);
	void * __fastcall First(void);
	int __fastcall IndexOf(void * Item);
	void __fastcall Insert(int Index, void * Item);
	void * __fastcall Last(void);
	void __fastcall Move(int CurIndex, int NewIndex);
	int __fastcall Remove(void * Item);
	TLookupItem* __fastcall LookupItem(AnsiString Name);
	TLookupItem* __fastcall FindItem(AnsiString Name);
	int __fastcall DeleteItem(AnsiString Name);
	int __fastcall FreeItem(AnsiString Name);
	__property int Count = {read=FCount, nodefault};
	__property TLookupItem* LookupItems[int Index] = {read=GetLookupItem/*, default*/};
	__property void * Items[int Index] = {read=Get};
};


class DELPHICLASS TLookupTable2;
class PASCALIMPLEMENTATION TLookupTable2 : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	void *FArray[18];
	int FCount;
	TLookupItem* __fastcall GetLookupItem(int Index);
	void * __fastcall Get(int Index);
	
public:
	__fastcall TLookupTable2(void);
	__fastcall virtual ~TLookupTable2(void);
	void __fastcall FreeItems(void);
	int __fastcall Add(void * Item);
	virtual void __fastcall Clear(void);
	void __fastcall Delete(int Index);
	void * __fastcall First(void);
	int __fastcall IndexOf(void * Item);
	void __fastcall Insert(int Index, void * Item);
	void * __fastcall Last(void);
	void __fastcall Move(int CurIndex, int NewIndex);
	int __fastcall Remove(void * Item);
	TLookupItem* __fastcall LookupItem(AnsiString Name);
	TLookupItem* __fastcall FindItem(AnsiString Name);
	int __fastcall DeleteItem(AnsiString Name);
	int __fastcall FreeItem(AnsiString Name);
	__property int Count = {read=FCount, nodefault};
	__property TLookupItem* LookupItems[int Index] = {read=GetLookupItem/*, default*/};
	__property void * Items[int Index] = {read=Get};
};


class DELPHICLASS TRapidEvaluator;
class PASCALIMPLEMENTATION TRapidEvaluator : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FToken;
	int FPos;
	bool FError_founded;
	AnsiString FErrorString;
	Byte token_type;
	int tok;
	TAbstractFunction* FCurFunc;
	AnsiString prog;
	TError error_type;
	TCode* Code;
	void *address;
	TCommandList* CommandList;
	TLookupTable* FExtFunctions;
	TLookupTable* FExtVariables;
	TLookupTable2* FIntFunctions;
	bool FCompiled;
	bool FAutoCompile;
	void __fastcall Level1(void);
	void __fastcall Level2(void);
	void __fastcall Level3(void);
	void __fastcall Level4(void);
	void __fastcall Level5(void);
	void __fastcall Level6(void);
	void __fastcall Primitive(void);
	void __fastcall Unary(char o);
	void __fastcall Arith(char o);
	void __fastcall PutBack(void);
	int __fastcall LookUp(AnsiString S);
	void __fastcall LevelFunction(void);
	void __fastcall GetToken(void);
	void __fastcall GetNumber(void);
	void __fastcall Error(AnsiString ErrStr);
	AnsiString __fastcall SError(Byte ErrCode, const System::TVarRec * Args, const int Args_Size);
	void __fastcall CheckForToken(AnsiString AToken);
	bool __fastcall IsDelim(char C);
	bool __fastcall IsWhite(char C);
	bool __fastcall IsDigit(char C);
	bool __fastcall IsAlpha(char C);
	void __fastcall FSetFormula(AnsiString Value);
	void __fastcall Translate(void);
	void __fastcall Build(void);
	
public:
	__fastcall virtual TRapidEvaluator(Classes::TComponent* AOwner);
	__fastcall virtual ~TRapidEvaluator(void);
	void __fastcall Compile(void);
	void __fastcall AddFunc(AnsiString Name, void * Addr, Byte ParamCount);
	int __fastcall DeleteFunc(AnsiString Name);
	void __fastcall AddVariable(AnsiString Name, void * Addr);
	int __fastcall DeleteVariable(AnsiString Name);
	double __fastcall Evaluate(void);
	double __fastcall Evaluate1D(double ax);
	double __fastcall Evaluate2D(double ax, double ay);
	double __fastcall Evaluate3D(double ax, double ay, double az);
	__property AnsiString Token = {read=FToken};
	__property int Position = {read=FPos, nodefault};
	__property AnsiString ErrorString = {read=FErrorString};
	__property bool Compiled = {read=FCompiled, nodefault};
	__property TLookupTable* ExtVariables = {read=FExtVariables};
	__property TLookupTable* ExtFunctions = {read=FExtFunctions};
	__property TLookupTable2* IntFunctions = {read=FIntFunctions};
	
__published:
	__property AnsiString Formula = {read=prog, write=FSetFormula};
	__property bool AutoCompile = {read=FAutoCompile, write=FAutoCompile, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE double _x;
extern PACKAGE double _y;
extern PACKAGE double _z;
extern PACKAGE AnsiString ErrEmptyExpression;
extern PACKAGE AnsiString ErrSyntaxError;
extern PACKAGE AnsiString ErrInvalidExpression;
extern PACKAGE AnsiString ErrInvalidNumber;
extern PACKAGE AnsiString ErrUnknownFV;
extern PACKAGE AnsiString ErrExpectedButFound;
extern PACKAGE AnsiString ErrNotEnoughFreeMem;
extern PACKAGE AnsiString ErrTooManyParams;
extern PACKAGE AnsiString ErrExtFuncExist;
extern PACKAGE AnsiString ErrIntFuncExist;
extern PACKAGE AnsiString ErrVariableExist;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Rapidevaluator */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rapidevaluator;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RapidEvaluator
