unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, RapidEvaluator, Buttons, CheckLst;

type
  TForm1 = class(TForm)
    edtFormula: TEdit;
    edtResult: TEdit;
    Bevel1: TBevel;
    btnEvaluate: TButton;
    CheckListBox1: TCheckListBox;
    CheckListBox2: TCheckListBox;
    CheckListBox3: TCheckListBox;
    RapidEvaluator: TRapidEvaluator;
    procedure btnEvaluateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  Math;

{$R *.DFM}

function _random: Double;
begin
  Result := Random;
end;

function _max(x1,x2 : Double): Double;
begin
  if x1 > x2 then
    Result := x1
  else
    Result := x2;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  RapidEvaluator.AddFunc('random', @_random, 0);
  RapidEvaluator.AddFunc('max', @_max, 2);
//  RapidEvaluator.DeleteFunc('random');

  for i := 0 to RapidEvaluator.IntFunctions.Count-1 do begin
    CheckListBox1.Items.Add(RapidEvaluator.IntFunctions[i].Name);
    CheckListBox1.Checked[i] := RapidEvaluator.IntFunctions[i].Enabled;
  end;
  for i := 0 to RapidEvaluator.ExtFunctions.Count-1 do begin
    CheckListBox2.Items.Add(RapidEvaluator.ExtFunctions[i].Name);
    CheckListBox2.Checked[i] := RapidEvaluator.ExtFunctions[i].Enabled;
  end;
  for i := 0 to RapidEvaluator.ExtVariables.Count-1 do begin
    CheckListBox3.Items.Add(RapidEvaluator.ExtVariables[i].Name);
    CheckListBox3.Checked[i] := RapidEvaluator.ExtVariables[i].Enabled;
  end;
end;

procedure TForm1.btnEvaluateClick(Sender: TObject);
begin
  RapidEvaluator.Formula := edtFormula.Text;
  try
    RapidEvaluator.Compile;
    edtFormula.SetFocus;
    edtFormula.SelectAll;
  except
    edtResult.Text := RapidEvaluator.ErrorString;
    edtFormula.SetFocus;
    edtFormula.SelStart := RapidEvaluator.Position-1;
    edtFormula.SelLength := 0;
    exit;
  end;
  try
    edtResult.Text := Format('%f', [RapidEvaluator.Evaluate]);
  except
    on E: Exception do
      edtResult.Text := E.Message;
  end;
end;

procedure TForm1.CheckListBox1ClickCheck(Sender: TObject);
var
  i : Integer;
begin
  if Sender = CheckListBox1 then
    for i := 0 to RapidEvaluator.IntFunctions.Count-1 do
      RapidEvaluator.IntFunctions[i].Enabled := TCheckListBox(Sender).Checked[i]
  else
  if Sender = CheckListBox2 then
    for i := 0 to RapidEvaluator.ExtFunctions.Count-1 do
      RapidEvaluator.ExtFunctions[i].Enabled := TCheckListBox(Sender).Checked[i]
  else
    for i := 0 to RapidEvaluator.ExtVariables.Count-1 do
      RapidEvaluator.ExtVariables[i].Enabled := TCheckListBox(Sender).Checked[i];
end;

end.

