//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RapidEvaluator"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

// our variable
double mx;

// let's declare the function to calculate the sum of 2 params
// note the __fastcall directive is required for proper work

double __fastcall f_sum2(double a, double b)
{
        return a+b;
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        RE->AddFunc("sum2", f_sum2, 2); // adding the function
        RE->AddVariable("mx", &mx);     // adding the variable
        mx = 2;                         // assign to mx the start value 
}
//---------------------------------------------------------------------------

// evaluating the formula
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        RE->Formula = edtFormula->Text;
        try {
                RE->Compile();
                double result = RE->Evaluate();
                Memo1->Lines->Add(Format("%.8f", ARRAYOFCONST((result))));
        }
        catch (Exception &exception) {
                Memo1->Lines->Add(exception.Message);
        }
        edtFormula->SetFocus();
}
//---------------------------------------------------------------------------

// tabulating the formula
void __fastcall TForm1::Button2Click(TObject *Sender)
{
        Memo1->Lines->Add("tabulating function sin(mx)");
        RE->Formula = "sin(mx)";
        RE->Compile();

        mx = 0;
        Memo1->Lines->BeginUpdate();
        while (mx <= 2*3.141519) {
                double result = RE->Evaluate();
                Memo1->Lines->Add(Format("mx=%f; sin(mx)=%.8f", ARRAYOFCONST((mx, result))));
                mx+=.01;
        }
        Memo1->Lines->EndUpdate();
}
//---------------------------------------------------------------------------

